
%include vaucanswig_algo_common.i
%{
#include <vaucanson/algorithms/brzozowski.hh>
%}
%define alg_brzozowski_interface(Automaton, GenAutomaton, Series, Exp, HList, Word, Letter)
static void brzozowski(Automaton& a, const Exp& e) ;
static void brzozowski(GenAutomaton& a, const Exp& e) ;
%enddef
%define alg_brzozowski_interface_impl(Automaton, GenAutomaton, Series, Exp, HList, Word, Letter)
static  void brzozowski(Automaton& a, const Exp& e) { return vcsn::brzozowski(*a, e); }
static  void brzozowski(GenAutomaton& a, const Exp& e) { return vcsn::brzozowski(*a, e); }
%enddef
%define alg_interface_brzozowski(Kind)
%{
struct Kind ##_alg_brzozowski {
alg_brzozowski_interface(Kind ##_types::Kind ##_auto_t, \
			Kind ##_types::gen_## Kind ##_auto_t, \
			Kind ##_types::Kind ##_series_set_elt_t, \
			Kind ##_types::Kind ##_exp_t, \
			std::list<int>, \
			std::basic_string<Kind ##_types::Kind ##_letter_t>, \
			Kind ##_types::Kind ##_letter_t)
};
%}
%enddef
%define decl_alg_brzozowski(Kind)
algo_common_decls(Kind)
%{
struct Kind ##_alg_brzozowski {
alg_brzozowski_interface_impl(Kind ##_types::Kind ##_auto_t, \
			Kind ##_types::gen_## Kind ##_auto_t, \
			Kind ##_types::Kind ##_series_set_elt_t, \
			Kind ##_types::Kind ##_exp_t, \
			std::list<int>, \
			std::basic_string<Kind ##_types::Kind ##_letter_t>, \
			Kind ##_types::Kind ##_letter_t)
};
%}
struct Kind ##_alg_brzozowski {
alg_brzozowski_interface(Kind ##_types::Kind ##_auto_t, \
			Kind ##_types::gen_## Kind ##_auto_t, \
			Kind ##_types::Kind ##_series_set_elt_t, \
			Kind ##_types::Kind ##_exp_t,
			std::list<int>,
			std::basic_string<Kind ##_types::Kind ##_letter_t>, \
			Kind ##_types::Kind ##_letter_t)
};
%enddef
