
%include vaucanswig_algo_common.i
%{
#include <vaucanson/algorithms/eval.hh>
%}
%define alg_eval_interface(Automaton, GenAutomaton, Series, Exp, HList, Word, Letter)
static Automaton::semiring_elt_t eval(const Automaton& a, const Word& s) ;
static Automaton::semiring_elt_t eval(const GenAutomaton& a, const Word& s) ;
%enddef
%define alg_eval_interface_impl(Automaton, GenAutomaton, Series, Exp, HList, Word, Letter)
static  Automaton::semiring_elt_t eval(const Automaton& a, const Word& s) { return vcsn::eval(*a, Series::monoid_elt_t((*a).structure().series().monoid(), s)).value(); }
static  Automaton::semiring_elt_t eval(const GenAutomaton& a, const Word& s) { return vcsn::eval(*a, Series::monoid_elt_t((*a).structure().series().monoid(), s)).value(); }
%enddef
%define alg_interface_eval(Kind)
%{
struct Kind ##_alg_eval {
alg_eval_interface(Kind ##_types::Kind ##_auto_t, \
			Kind ##_types::gen_## Kind ##_auto_t, \
			Kind ##_types::Kind ##_series_set_elt_t, \
			Kind ##_types::Kind ##_exp_t, \
			std::list<int>, \
			std::basic_string<Kind ##_types::Kind ##_letter_t>, \
			Kind ##_types::Kind ##_letter_t)
};
%}
%enddef
%define decl_alg_eval(Kind)
algo_common_decls(Kind)
%{
struct Kind ##_alg_eval {
alg_eval_interface_impl(Kind ##_types::Kind ##_auto_t, \
			Kind ##_types::gen_## Kind ##_auto_t, \
			Kind ##_types::Kind ##_series_set_elt_t, \
			Kind ##_types::Kind ##_exp_t, \
			std::list<int>, \
			std::basic_string<Kind ##_types::Kind ##_letter_t>, \
			Kind ##_types::Kind ##_letter_t)
};
%}
struct Kind ##_alg_eval {
alg_eval_interface(Kind ##_types::Kind ##_auto_t, \
			Kind ##_types::gen_## Kind ##_auto_t, \
			Kind ##_types::Kind ##_series_set_elt_t, \
			Kind ##_types::Kind ##_exp_t,
			std::list<int>,
			std::basic_string<Kind ##_types::Kind ##_letter_t>, \
			Kind ##_types::Kind ##_letter_t)
};
%enddef
