
%include vaucanswig_algo_common.i
%{
#include <vaucanson/algorithms/product.hh>
%}
%define alg_product_interface(Automaton, GenAutomaton, Series, Exp, HList, Word, Letter)
static Automaton product(const Automaton& a1, const Automaton& a2, const bool use_geometry) ;
%enddef
%define alg_product_interface_impl(Automaton, GenAutomaton, Series, Exp, HList, Word, Letter)
static  Automaton product(const Automaton& a1, const Automaton& a2, const bool use_geometry) { return vcsn::product(*a1, *a2); }
%enddef
%define alg_interface_product(Kind)
%{
struct Kind ##_alg_product {
alg_product_interface(Kind ##_types::Kind ##_auto_t, \
			Kind ##_types::gen_## Kind ##_auto_t, \
			Kind ##_types::Kind ##_series_set_elt_t, \
			Kind ##_types::Kind ##_exp_t, \
			std::list<int>, \
			std::basic_string<Kind ##_types::Kind ##_letter_t>, \
			Kind ##_types::Kind ##_letter_t)
};
%}
%enddef
%define decl_alg_product(Kind)
algo_common_decls(Kind)
%{
struct Kind ##_alg_product {
alg_product_interface_impl(Kind ##_types::Kind ##_auto_t, \
			Kind ##_types::gen_## Kind ##_auto_t, \
			Kind ##_types::Kind ##_series_set_elt_t, \
			Kind ##_types::Kind ##_exp_t, \
			std::list<int>, \
			std::basic_string<Kind ##_types::Kind ##_letter_t>, \
			Kind ##_types::Kind ##_letter_t)
};
%}
struct Kind ##_alg_product {
alg_product_interface(Kind ##_types::Kind ##_auto_t, \
			Kind ##_types::gen_## Kind ##_auto_t, \
			Kind ##_types::Kind ##_series_set_elt_t, \
			Kind ##_types::Kind ##_exp_t,
			std::list<int>,
			std::basic_string<Kind ##_types::Kind ##_letter_t>, \
			Kind ##_types::Kind ##_letter_t)
};
%enddef
